@echo off

 set dbUser=root
 set dbPassword=数据库root密码
 set backupDir="F:\DataBack\"
 set mysqldump="F:\MySQLBackups\zip\mysqldump.exe"
 set mysqlDataDir="D:\ProgramData\MySQL\MySQL Server 5.5\data\data"
 set zip="F:\MySQLBackups\zip\7za.exe"

 :: get date

 echo dirName=%date:~0,4%%date:~5,2%%date:~8,2%
 set dirName=%date:~0,4%%date:~5,2%%date:~8,2%
 
 :: switch to the "data" folder
 pushd %mysqlDataDir%

 :: iterate over the folder structure in the "data" folder to get the databases
 for /d %%f in (*) do (

 if not exist %backupDir%\%dirName%\ (
      mkdir %backupDir%\%dirName%
 )

 %mysqldump% --host="localhost" --user=%dbUser% --password=%dbPassword% --single-transaction --add-drop-table --databases %%f > %backupDir%\%dirName%\%%f.sql

 %zip% a -tgzip %backupDir%\%dirName%\%%f.sql.gz %backupDir%\%dirName%\%%f.sql

 del %backupDir%\%dirName%\%%f.sql
 )
 popd